from laktory._testing import StockPricesPipeline


def test_pipeline():
    pl = StockPricesPipeline()
    print(pl.model_dump())
    assert pl.model_dump() == {
        "allow_duplicate_names": None,
        "catalog": None,
        "channel": "PREVIEW",
        "clusters": [],
        "configuration": {},
        "continuous": None,
        "development": None,
        "edition": None,
        "libraries": [],
        "name": "pl-stock-prices",
        "notifications": [],
        "permissions": [],
        "photon": None,
        "serverless": None,
        "storage": None,
        "tables": [
            {
                "catalog_name": None,
                "columns": [],
                "data_source_format": "DELTA",
                "table_type": "MANAGED",
                "comment": None,
                "data": None,
                "grants": None,
                "name": "brz_stock_prices",
                "primary_key": None,
                "schema_name": None,
                "timestamp_key": None,
                "builder": {
                    "aggregation": None,
                    "drop_source_columns": False,
                    "drop_duplicates": None,
                    "drop_columns": [],
                    "event_source": {
                        "name": "stock_price",
                        "description": None,
                        "producer": None,
                        "events_root": "/Volumes/dev/sources/landing/events/",
                        "read_as_stream": True,
                        "type": "STORAGE_EVENTS",
                        "fmt": "JSON",
                        "multiline": False,
                        "header": True,
                        "read_options": {},
                    },
                    "filter": None,
                    "joins": [],
                    "joins_post_aggregation": [],
                    "layer": "BRONZE",
                    "pipeline_name": "pl-stock-prices",
                    "selects": None,
                    "table_source": None,
                    "template": "BRONZE",
                    "window_filter": None,
                },
                "view_definition": None,
                "warehouse_id": "08b717ce051a0261",
            },
            {
                "catalog_name": None,
                "columns": [
                    {
                        "catalog_name": None,
                        "comment": None,
                        "name": "created_at",
                        "pii": None,
                        "schema_name": None,
                        "spark_func_args": [
                            {
                                "value": "data._created_at",
                                "is_column": True,
                                "to_lit": False,
                            }
                        ],
                        "spark_func_kwargs": {},
                        "spark_func_name": "coalesce",
                        "sql_expression": None,
                        "table_name": "slv_stock_prices",
                        "type": "timestamp",
                        "unit": None,
                    },
                    {
                        "catalog_name": None,
                        "comment": None,
                        "name": "symbol",
                        "pii": None,
                        "schema_name": None,
                        "spark_func_args": [
                            {"value": "data.symbol", "is_column": True, "to_lit": False}
                        ],
                        "spark_func_kwargs": {},
                        "spark_func_name": "coalesce",
                        "sql_expression": None,
                        "table_name": "slv_stock_prices",
                        "type": "string",
                        "unit": None,
                    },
                    {
                        "catalog_name": None,
                        "comment": None,
                        "name": "open",
                        "pii": None,
                        "schema_name": None,
                        "spark_func_args": [
                            {"value": "data.open", "is_column": True, "to_lit": False}
                        ],
                        "spark_func_kwargs": {},
                        "spark_func_name": "coalesce",
                        "sql_expression": None,
                        "table_name": "slv_stock_prices",
                        "type": "double",
                        "unit": None,
                    },
                    {
                        "catalog_name": None,
                        "comment": None,
                        "name": "close",
                        "pii": None,
                        "schema_name": None,
                        "spark_func_args": [],
                        "spark_func_kwargs": {},
                        "spark_func_name": None,
                        "sql_expression": "data.open",
                        "table_name": "slv_stock_prices",
                        "type": "double",
                        "unit": None,
                    },
                ],
                "data_source_format": "DELTA",
                "table_type": "MANAGED",
                "comment": None,
                "data": [
                    ["2023-11-01T00:00:00Z", "AAPL", 1, 2],
                    ["2023-11-01T01:00:00Z", "AAPL", 3, 4],
                    ["2023-11-01T00:00:00Z", "GOOGL", 3, 4],
                    ["2023-11-01T01:00:00Z", "GOOGL", 5, 6],
                ],
                "grants": None,
                "name": "slv_stock_prices",
                "primary_key": None,
                "schema_name": None,
                "timestamp_key": None,
                "builder": {
                    "aggregation": None,
                    "drop_source_columns": True,
                    "drop_duplicates": None,
                    "drop_columns": [],
                    "event_source": None,
                    "filter": None,
                    "joins": [],
                    "joins_post_aggregation": [],
                    "layer": "SILVER",
                    "pipeline_name": "pl-stock-prices",
                    "selects": None,
                    "table_source": {
                        "read_as_stream": True,
                        "catalog_name": "dev",
                        "cdc": None,
                        "selects": None,
                        "filter": None,
                        "from_pipeline": True,
                        "name": "brz_stock_prices",
                        "schema_name": "markets",
                        "watermark": None,
                    },
                    "template": "SILVER",
                    "window_filter": None,
                },
                "view_definition": None,
                "warehouse_id": "08b717ce051a0261",
            },
        ],
        "target": None,
        "udfs": [{"module_name": "stock_functions", "function_name": "high"}],
    }


if __name__ == "__main__":
    test_pipeline()
